Loading...
Searching...
No Matches
openshot::ColorMap Class Reference

Applies a 1D or 3D LUT (.cube) color transform to each frame. More...

`#include <effects/ColorMap.h>`

Inheritance diagram for openshot::ColorMap:

## Public Member Functions

| ColorMap ()
| Blank constructor (used by JSON loader).
| ColorMap (const std::string &path, const Keyframe &i=Keyframe(1.0), const Keyframe &iR=Keyframe(1.0), const Keyframe &iG=Keyframe(1.0), const Keyframe &iB=Keyframe(1.0))
| Constructor with LUT path and per‐channel intensities.
std::shared_ptr< openshot::Frame > | GetFrame (int64_t frame_number) override
| Apply effect to a new frame.
std::shared_ptr< openshot::Frame > | GetFrame (std::shared_ptr< openshot::Frame > frame, int64_t frame_number) override
| Apply effect to an existing frame.
std::string | Json () const override
| Generate JSON string of this object.
Json::Value | JsonValue () const override
| Generate Json::Value for this object.
std::string | PropertiesJSON (int64_t requested_frame) const override
| Expose properties (for UI).
void | SetJson (const std::string value) override
| Load JSON string into this object.
void | SetJsonValue (const Json::Value root) override
| Load Json::Value into this object.
Public Member Functions inherited from openshot::EffectBase
Json::Value | BasePropertiesJSON (int64_t requested_frame) const
| Generate JSON object of base properties (recommended to be used by all effects).
int | constrain (int color_value)
| Constrain a color value from 0 to 255.
void | DisplayInfo (std::ostream *out=&std::cout)
| Display effect information in the standard output stream (stdout).
virtual std::string | GetVisibleObjects (int64_t frame_number) const
| Get the indexes and IDs of all visible objects in the given frame.
void | InitEffectInfo ()
virtual std::string | Json (int64_t requested_frame) const
Json::Value | JsonInfo () const
| Generate JSON object of meta data / info.
int | Order () const
| Get the order that this effect should be executed.
void | Order (int new_order)
| Set the order that this effect should be executed.
openshot::ClipBase * | ParentClip ()
| Parent clip object of this effect (which can be unparented and NULL).
void | ParentClip (openshot::ClipBase *new_clip)
| Set parent clip object of this effect.
std::string | ParentClipId () const
| Return the ID of this effect's parent clip.
virtual void | SetJson (int64_t requested_frame, const std::string value)
void | SetParentEffect (std::string parentEffect_id)
| Set the parent effect from which this properties will be set to.
virtual | ~EffectBase ()=default
Public Member Functions inherited from openshot::ClipBase
| ClipBase ()
| Constructor for the base clip.
float | Duration () const
| Get the length of this clip (in seconds).
virtual float | End () const
| Get end position (in seconds) of clip (trim end of video).
virtual void | End (float value)
| Set end position (in seconds) of clip (trim end of video).
std::string | Id () const
| Get the Id of this clip object.
void | Id (std::string value)
int | Layer () const
| Get layer of clip on timeline (lower number is covered by higher numbers).
void | Layer (int value)
| Set layer of clip on timeline (lower number is covered by higher numbers).
bool | operator< (ClipBase &a)
bool | operator<= (ClipBase &a)
bool | operator> (ClipBase &a)
bool | operator>= (ClipBase &a)
virtual openshot::TimelineBase * | ParentTimeline ()
| Get the associated Timeline pointer (if any).
virtual void | ParentTimeline (openshot::TimelineBase *new_timeline)
| Set associated Timeline pointer.
float | Position () const
| Get position on timeline (in seconds).
void | Position (float value)
| Set position on timeline (in seconds).
float | Start () const
| Get start position (in seconds) of clip (trim start of video).
void | Start (float value)
| Set start position (in seconds) of clip (trim start of video).
virtual | ~ClipBase ()=default

## Public Attributes

Keyframe | intensity
| Overall intensity 0–1 (affects all channels).
Keyframe | intensity_b
| Blend 0–1 for blue channel.
Keyframe | intensity_g
| Blend 0–1 for green channel.
Keyframe | intensity_r
| Blend 0–1 for red channel.
Public Attributes inherited from openshot::EffectBase
EffectInfoStruct | info
| Information about the current effect.
EffectBase * | parentEffect
| Parent effect (which properties will set this effect properties).
std::map< int, std::shared_ptr< openshot::TrackedObjectBase > > | trackedObjects
| Map of Tracked Object's by their indices (used by Effects that track objects on clips).

## Additional Inherited Members

Protected Member Functions inherited from openshot::ClipBase
Json::Value | add_property_choice_json (std::string name, int value, int selected_value) const
| Generate JSON choice for a property (dropdown properties).
Json::Value | add_property_json (std::string name, float value, std::string type, std::string memo, const Keyframe *keyframe, float min_value, float max_value, bool readonly, int64_t requested_frame) const
| Generate JSON for a property.
Protected Attributes inherited from openshot::EffectBase
openshot::ClipBase * | clip
| Pointer to the parent clip instance (if any).
Protected Attributes inherited from openshot::ClipBase
float | end
| The position in seconds to end playing (used to trim the ending of a clip).
std::string | id
| ID Property for all derived Clip and Effect classes.
int | layer
| The layer this clip is on. Lower clips are covered up by higher clips.
float | position
| The position on the timeline where this clip should start playing.
std::string | previous_properties
| This string contains the previous JSON properties.
float | start
| The position in seconds to start playing (used to trim the beginning of a clip).
openshot::TimelineBase * | timeline
| Pointer to the parent timeline instance (if any).

## Detailed Description

Applies a 1D or 3D LUT (.cube) color transform to each frame.

Loads a .cube file (supporting LUT_1D_SIZE and LUT_3D_SIZE) into memory, then for each pixel interpolates the lookup value and blends the result by keyframable per‐channel intensities.

Definition at line 35 of file ColorMap.h.

## Constructor & Destructor Documentation

## ColorMap() [1/2]

ColorMap::ColorMap | ( |  | ) |

Blank constructor (used by JSON loader).

Definition at line 149 of file ColorMap.cpp.

## ColorMap() [2/2]

ColorMap::ColorMap | ( | const std::string & | path,
|  | const Keyframe & | i = Keyframe(1.0),
|  | const Keyframe & | iR = Keyframe(1.0),
|  | const Keyframe & | iG = Keyframe(1.0),
|  | const Keyframe & | iB = Keyframe(1.0) )

Constructor with LUT path and per‐channel intensities.

Parameters

  path | Filesystem path to .cube file
  i | Keyframe for overall intensity (0–1)
  iR | Keyframe for red blend (0–1)
  iG | Keyframe for green blend (0–1)
  iB | Keyframe for blue blend (0–1)

Definition at line 158 of file ColorMap.cpp.

## Member Function Documentation

## GetFrame() [1/2]

std::shared_ptr< openshot::Frame > openshot::ColorMap::GetFrame | ( | int64_t | frame_number | ) |

inline override virtual

Apply effect to a new frame.

Implements openshot::ClipBase.

Definition at line 80 of file ColorMap.h.

Referenced by GetFrame().

## GetFrame() [2/2]

std::shared_ptr< openshot::Frame > ColorMap::GetFrame | ( | std::shared_ptr< openshot::Frame > | frame,
|  | int64_t | frame_number )

override virtual

Apply effect to an existing frame.

Implements openshot::ClipBase.

Definition at line 178 of file ColorMap.cpp.

## Json()

std::string ColorMap::Json | ( |  | ) | const

override virtual

Generate JSON string of this object.

Reimplemented from openshot::EffectBase.

Definition at line 321 of file ColorMap.cpp.

## JsonValue()

Json::Value ColorMap::JsonValue | ( |  | ) | const

override virtual

Generate Json::Value for this object.

Reimplemented from openshot::EffectBase.

Definition at line 326 of file ColorMap.cpp.

Referenced by Json().

## PropertiesJSON()

std::string ColorMap::PropertiesJSON | ( | int64_t | requested_frame | ) | const

override virtual

Expose properties (for UI).

Implements openshot::ClipBase.

Definition at line 367 of file ColorMap.cpp.

## SetJson()

void ColorMap::SetJson | ( | const std::string | value | ) |

override virtual

Load JSON string into this object.

Reimplemented from openshot::EffectBase.

Definition at line 338 of file ColorMap.cpp.

## SetJsonValue()

void ColorMap::SetJsonValue | ( | const Json::Value | root | ) |

override virtual

Load Json::Value into this object.

Reimplemented from openshot::EffectBase.

Definition at line 349 of file ColorMap.cpp.

Referenced by SetJson().

## Member Data Documentation

## intensity

Keyframe openshot::ColorMap::intensity

Overall intensity 0–1 (affects all channels).

Definition at line 55 of file ColorMap.h.

Referenced by ColorMap(), ColorMap(), GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## intensity_b

Keyframe openshot::ColorMap::intensity_b

Blend 0–1 for blue channel.

Definition at line 58 of file ColorMap.h.

Referenced by ColorMap(), ColorMap(), GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## intensity_g

Keyframe openshot::ColorMap::intensity_g

Blend 0–1 for green channel.

Definition at line 57 of file ColorMap.h.

Referenced by ColorMap(), ColorMap(), GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## intensity_r

Keyframe openshot::ColorMap::intensity_r

Blend 0–1 for red channel.

Definition at line 56 of file ColorMap.h.

Referenced by ColorMap(), ColorMap(), GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

The documentation for this class was generated from the following files:

- effects/ColorMap.h
- effects/ColorMap.cpp